#include "membermodel.h"

#include "room.h"

int MemberModel::rowCount(const QModelIndex& parent) const {
    if (!room)
        return 0;

    return room->members.size();
}

QVariant MemberModel::data(const QModelIndex& index, int role) const {
    if (!room)
        return "";

    if (index.row() >= room->members.size())
        return "";

    if (role == DisplayNameRole)
        return room->members.at(index.row())->getDisplayName();
    else if (role == AvatarURLRole)
        return room->members.at(index.row())->getAvatar();
    else if (role == IdRole)
        return room->members.at(index.row())->getId();
    else {
        int powerLevel = room->powerLevelList[room->members.at(index.row())->getId()];
        if (powerLevel == 100)
            return "Admin";
        else if (powerLevel == 50)
            return "Moderator";
        else
            return "User";
    }
}

QHash<int, QByteArray> MemberModel::roleNames() const {
    QHash<int, QByteArray> roles;
    roles[DisplayNameRole] = "displayName";
    roles[AvatarURLRole] = "avatarURL";
    roles[IdRole] = "id";
    roles[SectionRole] = "section";

    return roles;
}
